package com.platform.yijia.controller;

import com.alibaba.fastjson.JSON;
import com.google.gson.Gson;
import com.platform.yijia.config.YiJiaRequest;
import com.platform.yijia.param.request.PayInfoRequest;
import com.platform.yijia.service.*;
import com.platform.yijia.utils.ResultData;
import com.platform.yijia.utils.weixinapp.WxPushUtil;
import com.saobei.open.sdk.DefaultSaobeiApiClient;
import com.saobei.open.sdk.SaobeiApiClient;
import com.saobei.open.sdk.model.requst.trade.SaobeiMiniPayRequest;
import com.saobei.open.sdk.model.response.trade.SaobeiMiniPayResponse;
import net.sf.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;


/*
 * <Title> SaoBeiPayController </Title>
 * <Description> 第三方扫呗支付 </Description>
 * @Author JK
 * @Date 2021年8月18日
 */

@Controller
@YiJiaRequest()
@CrossOrigin
public class SaoBeiPayController {
    private static Logger logger =(Logger) LoggerFactory.getLogger(SaoBeiPayController.class);

    @Resource
    private PayOrderService payOrderService;
    @Resource
    private AppUserInfoService appUserInfoService;
    @Resource
    private StationOilGunService stationOilGunService;
    @Resource
    private CustomerGradeServices customerGradeServices;
    @Resource
    private StationService stationService;
    @Resource
    private CustomerPointsService customerPointsService;
    @Resource
    private IntegralRuleService integralRuleService;
    @Resource
    private CustomerPointsRecordService customerPointsRecordService;
    @Resource
    private WxPushUtil wxPushUtil;
    @Resource
    private GzhNewsTemplateService gzhNewsTemplateService;
    @Resource
    private  CustomerManagerService customerManagerService;
    @Value("${yijia.path.global-prefix}")
    private String globalPrefix;
    @Value("${yijia.domainName}")
    private String domainName;

//    商户号:852107011000070
//    终端号：33336510
//    密钥(token)：dbea558077934b95a2f2adf57d278c40

//    商户号码：852105942000011
//    终端号：18237172
//    密钥：2ef428f4f76c414282e831baea9e4b0e

    public static final String PAY_VER = "110";//版本号
    public static final String KEY = "";//机构秘钥
    public static final String ACCESS_TOKEN = "2ef428f4f76c414282e831baea9e4b0e";//支付秘钥
    public static final String INST_NO = "";//机构号
    public static final String MERCHANT_NO = "852105942000011";//商户号
    public static final String TERMINAL_ID = "18237172";//终端号


    /***
     * 支付接口，前台上传支付信息，支付数据落地生产订单，调用第三方扫呗支付
     * 小程序支付接口
     * @param payInfoRequest
     * @return
     */
    @RequestMapping(value = "/payAmtInfo", consumes = "application/json", method = RequestMethod.POST)
    @ResponseBody
    public String payAmtInfo(@RequestBody PayInfoRequest payInfoRequest) throws Exception {
        Gson gson =new Gson();
        ResultData resultData =null;
        //创建client
        SaobeiApiClient<SaobeiMiniPayRequest, SaobeiMiniPayResponse> client = new DefaultSaobeiApiClient<>(ACCESS_TOKEN);
        //创建requst
        SaobeiMiniPayRequest requst = new SaobeiMiniPayRequest();
        requst.setPay_ver(PAY_VER);
        requst.setPay_type("010");
        requst.setService_id("015");
        requst.setMerchant_no(MERCHANT_NO);
        requst.setTerminal_id(TERMINAL_ID);


        requst.setTerminal_trace("202003252204310000");         //终端流水号，填写商户系统的订单号
        requst.setTerminal_time("20200325220431");              //交易时间
        String amt = payInfoRequest.getAmt();
        requst.setTotal_fee("1");                               //订单金额
        String openId = payInfoRequest.getOpenId();
        requst.setOpen_id("obnG9jhDLvom5fGwuhYysmQTW4qQ");       //微信用户openId
        requst.setOrder_body("sdk测试");

        String notifyUrl = "https://"+domainName+"/"+globalPrefix+"/getSaobeiCallback";
        logger.info("扫呗调用回调地址：" + notifyUrl);
        requst.setNotify_url(notifyUrl);

        requst.setSub_appid("wxe568c727d466aef9");
        //发送请求
        System.out.println("请求报文:"+ JSON.toJSONString(requst));
        SaobeiMiniPayResponse response = client.execute(requst);
        System.out.println("返回报文:"+JSON.toJSONString(response));
        resultData = ResultData.success(response);
        return gson.toJson(resultData);
    }

    /***
     * 扫呗回调
     * @param jsonObject
     * @return
     */
    @RequestMapping(value = "/getSaobeiCallback", consumes = "application/json", method = RequestMethod.POST)
    @ResponseBody
    public JSONObject getSaobeiCallback(@RequestBody JSONObject jsonObject){
        JSONObject result = new JSONObject();
        result.put("code", "success");
        return result;
    }

}
